//
//  CompoundStudent - diese Version der Klasse Student enthlt ein
//                    Datenelement, das einen benutzerdefinierten
//                    Typ hat
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;

class StudentID
{
  protected:
    static int nBaseValue;
    int        nValue;

  public:
    StudentID()
    {
        nValue = nBaseValue++;
    }

    StudentID(int nNewValue)
    {
        nValue = nNewValue;
    }

    int getID()
    {
        return nValue;
    }
};

// Speicherplatz fr die Klasseneigenschaft reserviere
int StudentID::nBaseValue = 1000;

class Student
{
  protected:
    char*        pszName;
    StudentID    sID;

    void initName(const char* pszNewName)
    {
        int nLength = strlen(pszNewName) + 1;
        pszName = new char[nLength];
        strcpy(pszName, pszNewName);
    }

  public:
    Student(const char* pszNewName,
                  int nNewID) : sID(nNewID)
    {
        initName(pszNewName);
    }
    Student(const char* pszNewName)
    {
        initName(pszNewName);
    }
   ~Student()
    {
        delete[] pszName;
        pszName = nullptr;
    }

    // getName() - den Namen des Studenten ermitteln
    const char* getName()
    {
        return pszName;
    }

    // getID() - ID des Studenten ermitteln
    int getID()
    {
        return sID.getID();
    }
};


int main(int nNumberofArgs, char* pszArgs[])
{
    // Studenten erstellen und initialisieren
    Student student1("Stephen Davis");

    // Namen und ID des Studenten anzeigen
    cout << "Der Name des ersten Studenten lautet "
         << student1.getName()
         << ", die ID ist "
         << student1.getID()
         << endl;

    // dasselbe fr den zweiten Studenten
    Student student2("Janet Eddins");
    cout << "Der Name des zweiten Studenten lautet "
         << student2.getName()
         << ", die ID ist "
         << student2.getID()
         << endl;

    // jetzt einen Transferstudenten mit eindeutiger ID erstellen
    Student student3("Tiffany Amrich", 1234);
    cout << "Der Name des dritten Studenten lautet "
         << student3.getName()
         << ", die ID ist "
         << student3.getID()
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
