//
//  ConcatenateError2 - diese Version korrigiert einen der Fehler
//                      in ConcatenateError1.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;


// concatenateString - Verknpfung von zwei Zeichenketten in einem
//                     auf dem Stapel reservierten Array
char* concatenateString(const char* pszSrc1,
                        const char* pszSrc2)
{
    // ein Array ausreichender Lnge reservieren
    int nTargetSize = strlen(pszSrc1)+strlen(pszSrc2)+1;
    char* pszTarget = new char[nTargetSize];
    char* pszT = pszTarget;  // save a pointer to return

    // zuerst die erste Zeichenkette in das Ziel kopieren
    while(*pszSrc1 != '\0')
    {
        *pszTarget++ = *pszSrc1++;
    }

    // jetzt den Inhalt der zweiten Zeichenkette am
    // Ende der ersten
    while(*pszSrc2 != '\0')
    {
        *pszTarget++ = *pszSrc2++;
    }

    // Rckgabe des unvernderten Zeigers an den Aufrufer
    return pszT;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft wieder aus.\n" << endl;

    // Eingabe von zwei Zeichenketten
    cout << "Eingabe der ersten Zeichenkette: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Eingabe der zweiten Zeichenkette: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt die erste Zeichenkette an die zweite anfgen
    cout << "Die zweite Zeichenkette mit der ersten verknpfen"
         << endl;
    char* pszT = concatenateString(szString1, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << pszT
         << ">" << endl;

    // den Speicher an den Stapel zurckgeben
    delete pszT;
    pszT = nullptr;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
