//
//  ConcatenateHeap - hnlich wie ConcatenateString, auer dass
//                    diese Version die verknpften Zeichenketten
//                    in dem auf dem Stapel reservierten Speicher
//                    ablegt, sodass garantiert ist, dass das Array
//                    immer gro genug ist
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;


// concatenateString - verknpft zwei Zeichenketten in einem
//                     auf dem Stapel reservierten Array

char* concatenateString(const char szSrc1[],
                        const char szSrc2[])
{
    // reserviert ein Array ausreichender Lnge
    int nTargetSize = strlen(szSrc1) + strlen(szSrc2) + 1;
    char* pszTarget = new char[nTargetSize];

    // zuerst die erste Zeichenkette in das Ziel kopieren
    int nT;
    for(nT = 0; szSrc1[nT] != '\0'; nT++)
    {
        pszTarget[nT] = szSrc1[nT];
    }

    // jetzt den Inhalt der zweiten Zeichenkette an das Ende
    // der ersten anfgen
    for(int nS = 0; szSrc2[nS] != '\0'; nT++, nS++)
    {
        pszTarget[nT] = szSrc2[nS];
    }

    // Abschluss fr szTarget hinzufgen
    pszTarget[nT] = '\0';

    // die Ergebnisse an den Aufrufer zurckgeben
    return pszTarget;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft aus.\n" << endl;

    // zwei Zeichenketten eingeben
    cout << "Eingabe der ersten Zeichenkette: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Eingabe der zweiten Zeichenkette: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt den einen am Ende des anderen anfgen
    cout << "Zweite Zeichenkette an die erste anfgen"
         << endl;
    char* pszT = concatenateString(szString1, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << pszT
         << ">" << endl;

    // den Speicher an den Stapel zurckgeben
    delete[] pszT;
    pszT = nullptr;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
