//
//  ConcatenatePtr - dies ist die Zeigerversion des Programms
//                   ConcatenateHeap. Diese Version demonstriert
//                   die Aehnlichkeit zwischen einem Zeiger und
//                   einem Array
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;


// concatenateString - verknpft die beiden Zeichenketten zu
//                     einem Array, das auf dem Stapel reserviert wurde
char* concatenateString(const char* pszSrc1,
                        const char* pszSrc2)
{
    // ein Array ausreichender Lnge reservieren
    int nTargetSize = strlen(pszSrc1)+strlen(pszSrc2)+1;
    char* pszTarget = new char[nTargetSize];

    // zuerst die erste Zeichenkette in das Ziel kopieren
    char* pszT = pszTarget;
    for(; *pszSrc1 != '\0'; pszT++, pszSrc1++)
    {
        *pszT = *pszSrc1;
    }

    // jetzt den Inhalt der zweiten Zeichenkette an das
    // Ende der ersten anfgen
    for(; *pszSrc2 != '\0'; pszT++, pszSrc2++)
    {
        *pszT = *pszSrc2;
    }

    // Abschluss fr szTarget hinzufgen
    *pszT = '\0';

    // die unvernderte Adresse des Arrays
    // an den Aufrufer zurckgeben
    return pszTarget;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft aus.\n" << endl;

    // Eingabe von zwei Zeichenketten
    cout << "Eingabe der ersten Zeichenkette: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Eingabe der zweiten Zeichenkette: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt eine an das Ende der anderen einfgen
    cout << "Die erste Zeichenkette an die zweite anfgen"
         << endl;
    char* pszT = concatenateString(szString1, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << pszT
         << ">" << endl;

    // den Speicher an den Stapel zurckgeben
    delete pszT;
    pszT = nullptr;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
