//
//  CopyFiles - legt Sicherungskopien der dem Programm bergebenen
//              Dateien an, indem es eine Datei desselben Namens
//              erstellt, wobei dem Namen die Dateinamenerweiterung
//              ".backup" hinzugefgt wird.
//
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
#include <cstring>
using namespace std;

void copyFile(const char* pszSrcFileName)
{
    // eine Kpie der bergebenen Datei, mit
    // ".backup" am Ende des Dateinamens
    int nTargetNameLength = strlen(pszSrcFileName) + 10;
    char *pszTargetFileName = new char[nTargetNameLength];
    strcpy(pszTargetFileName, pszSrcFileName);
    strcat(pszTargetFileName, ".backup");

    // jetzt die Quelldatei fr die Eingabe und die
    // Zieldatei fr die Ausgabe ffnen
    ifstream input(pszSrcFileName,
                   ios_base::in | ios_base::binary);
    if (input.good())
    {
        ofstream output(pszTargetFileName,
      ios_base::out | ios_base::binary | ios_base::trunc);
        if (output.good())
        {

            while (!input.eof() && input.good())
            {
                char buffer[4096];
                input.read(buffer, 4096);
                output.write(buffer, input.gcount());
            }
        }
    }

    // Speicher auf dem Stapel wiederherstellen
    delete pszTargetFileName;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // die main() bergebenen Dateinamen der Funktion
    // copyFile() bergeben, jeweils einzeln
    for (int i = 1; i < nNumberofArgs; i++)
    {
        cout << "Kopieren " << pszArgs[i] << endl;
        copyFile(pszArgs[i]);
    }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

