//
//  DeepStudent - dieses Programm zeigt, wie ein Copy-Konstruktor
//                fr eine tiefe Kopie genutzt werden kann, um
//                Probleme mit dem Kopieren zu beheben
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;

class Student
{
  protected:
    char*  pszName;
    int    nID;

  public:
    Student(const char* pszNewName, int nNewID)
    {
        cout << "Konstruktion von " << pszNewName << endl;
        int nLength = strlen(pszNewName) + 1;
        pszName = new char[nLength];
        strcpy(pszName, pszNewName);
        nID = nNewID;
    }
    Student(const Student& s)
    {
        cout<<"Konstruktion der Kopie von "<< s.pszName << endl;

        int nLength = strlen(s.pszName) + 25;
        this->pszName = new char[nLength];
        strcpy(this->pszName, "Copy of ");
        strcat(this->pszName, s.pszName);
        this->nID = s.nID;
    }

   ~Student()
    {
        cout << "Zerstren von " << pszName << endl;
        delete[] pszName;
        pszName = nullptr;
    }

    // Zugriffsfunktionen
    const char* getName()
    {
        return pszName;
    }
    int getID()
    {
        return nID;
    }
};

void someOtherFn(Student s)
{
    // hier brauchen wir nichts mehr zu tun
}

void someFn()
{
    Student student("Adam Laskowski", 1234);
    someOtherFn(student);

    cout << "Der Name des Studenten ist jetzt "
         << student.getName() << endl;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    someFn();

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
