// FactorialException - demonstriert den Ausnahmefehler-Verarbeitungsmechanismus
//                      anhand einer Fakulttfunktion.
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// factorial - Berechnung der Fakultt
int factorial(int n)
{
    // das Argument muss positiv sein; Ausnahme, wenn
    // n negativ ist
    if (n < 0)
    {
        throw "Das Argument fr die Fakultt ist negativ";
    }

    // alles ber 100 erzeugt einen berlauf
    if (n > 100)
    {
        throw "Argument zu gro";
    }

    // jetzt die Fakultt berechnen
    int nAccum = 1;
    while(n > 1)
    {
        nAccum *= n--;
    }
    return nAccum;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    try
    {
        cout << "Fakultt von 3 ist "
             << factorial(3)
             << endl;

        cout << "Fakultt von -1 ist "
             << factorial(-1)
             << endl;

        cout << "Fakultt von 5 ist "
             << factorial(5)
             << endl;
    }
    catch(const char* pMsg)
    {
        cerr << "Fehler aufgetreten: " << pMsg << endl;
    }
    catch(...)
    {
        cerr << "Unerwarteter Fehler aufgeworfen" << endl;
    }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
