//
//  FunctionDemo - demonstriert, wie eine Funktion genutzt wird,
//                 um die Programmlogik zu vereinfachen.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

//
// sumSequence() - Rckgabe der Summe einer vom Benutzer eingegebenen
//                 Zahlenreihe. Die Schleife wird verlassen,
//                 wenn der Benutzer eine negative Zahl
//                 eingibt.
int sumSequence()
{
    // eine Variable einrichtne, die die vom Benutzer eingegebenen
    // Zahlen addiert
    int nAccumulator = 0;

    for(;;)
    {
        // einen weiteren Wert vom Benutzer lesen
        int nValue;
        cout << "Nchster: ";
        cin  >> nValue;

        // Beenden, wenn nValue negativ ist
        if (nValue < 0)
        {
            break;
        }

        // dem akkumulierten Wert den eingegebenen Wert hinzufgen
        nAccumulator += nValue;
    }

    // den akkumulierten Wert an den Aufrufer zurckgeben
    return nAccumulator;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    cout << "Dieses Programm summiert Zahlenfolgen.\n"
         << "Geben Sie eine Zahlenfolge ein. Bei Eingabe\n"
         << "einer negativen Zahl gibt das Programm die\n"
         << "Summe aus und beginnt eine neue\n"
         << "Folge. "
         << "Mit der Eingabe von zwei negativen Werten nacheinander\n"
         << "wird das Programm beendet." << endl;

    // in einer Schleife Eingaben vom Benutzer entgegennehmen,
    // bis der Benutzer eine negative Zahl eingibt
    for(;;)
    {
        // eine Folge akkumulieren
        int nSum = sumSequence();

        // wenn die Summe null ist...
        if (nSum == 0)
        {
            // ...das Programm beenden
            break;
        }

        // das Ergebnis anzeigen
        cout << "Sum = " << nSum << endl;
     }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

