//
//  GSInherit - demonstriert die Vererbung durch Erstellung einer
//              Klasse GraduateStudent, die von
//              Student erbt.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;

class Student
{
  protected:
    char*  pszName;
    int    nID;
    double dGrade;         // GPA des Studenten
    int    nSemesterHours;

  public:
    Student(const char* pszNewName, int nNewID)
    {
        cout << "Konstruktion des Studenten "
             << pszNewName << endl;
        pszName = new char[strlen(pszNewName) + 1];
        strcpy(pszName, pszNewName);
        nID = nNewID;
        dGrade = 0.0;
        nSemesterHours = 0;
    }
   ~Student()
    {
        cout << "Zerstren " << pszName << endl;
        delete[] pszName;
        pszName = nullptr;
    }

    // Zugrifffunktionen
    const char* getName()
    {
        return pszName;
    }
    int getID()
    {
        return nID;
    }
    double getGrade()
    {
        return dGrade;
    }
    int getHours()
    {
        return nSemesterHours;
    }

    // addGrade - addiert eine Note zum GPA und ermittelt die Stunden
    double addGrade(double dNewGrade, int nHours)
    {
        double dWtdHrs = dGrade * nSemesterHours;
        dWtdHrs += dNewGrade * nHours;
        nSemesterHours += nHours;
        dGrade = dWtdHrs / nSemesterHours;
        return dGrade;
    }
};

class Advisor
{
  public:
    Advisor() { cout << "Advisor konstruiert" << endl;}
};

class GraduateStudent : public Student
{
  protected:
    double dQualifierGrade;
    Advisor advisor;

  public:
    GraduateStudent(const char* pszName, int nID) :
       Student(pszName, nID)
    {
        cout << "Konstruktion GraduateStudent" << endl;
        dQualifierGrade = 0.0;
    }
};

void someOtherFn(Student* pS)
{
    cout << "Student bergeben " << pS->getName() << endl;
}

void someFn()
{
    Student student("Lo Lee Undergrad", 1234);
    someOtherFn(&student);

    GraduateStudent gs("Upp R. Class", 5678);
    someOtherFn(&gs);
}

int main(int nNumberofArgs, char* pszArgs[])
{
    someFn();

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
