// InputPerson - Erstellen von Objekten der Klasse Person und
//               Anzeige ihrer Daten
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// Person - speichert den Namen und die Sozialversicherungsnummer
class Person
{
  public:
    char szFirstName[128];
    char szLastName[128];
    int  nSocialSecurityNumber;
};

// getPerson - ein Person-Objekt von der Tastatur einlesen
//             und eine Kopie an den Aufrufer zurckgeben
Person getPerson()
{
    Person person;

    cout << "\nEingabe einer weiteren Person\n"
         << "Vorname: ";
    cin  >> person.szFirstName;

    cout << "Nachname: ";
    cin  >> person.szLastName;

    cout << "Sozialversicherungsnummer: ";
    cin  >> person.nSocialSecurityNumber;

    return person;
}

// getPeople - ein Array mit Person-Objekten lesen
//             und die gelesene Anzahl zurckgeben
int getPeople(Person people[], int nMaxSize)
{
    // weiter, bis der Operator sagt, er ist fertig,
    // oder bis wir keinen Platz mehr haben
    int index;
    for(index = 0; index < nMaxSize; index++)
    {
        char cAnswer;
        cout << "Einen weiteren Namen eingeben? (J oder N):";
        cin  >> cAnswer;

        if (cAnswer != 'J' && cAnswer != 'j')
        {
            break;
        }

        people[index] = getPerson();
    }
    return index;
}

// displayPerson - eine Person auf der Standardanzeige anzeigen
void displayPerson(Person person)
{
    cout << "Vorname: " << person.szFirstName << endl;
    cout << "Nachname: " << person.szLastName  << endl;
    cout << "Sozialversicherungsnummer: "
         << person.nSocialSecurityNumber << endl;
}

// displayPeople - ein Array mit Person-Objekten anzeigen
void displayPeople(Person people[], int nCount)
{
    for(int index = 0; index < nCount; index++)
    {
        displayPerson(people[index]);
    }
}

// sortPeople - ein Array mit nCount Person-Objekten nach der
//              Sozialversicherungsnummer sortieren
//              (binre Sortierung)
void sortPeople(Person people[], int nCount)
{
    // weiter, bis die Liste korrekt ist
    int nSwaps = 1;
    while(nSwaps != 0)
    {
        // wir erkennen, dass die Liste in Ordnung ist, anhand der
        // Anzahl der zu vertauschenden Datenstze
        nSwaps = 0;

        // Liste durchlaufen
        for(int n = 0; n < (nCount - 1); n++)
        {
            // ...wenn der aktuelle Eintrag grer als der
            // folgende Eintrag ist...
            if (people[n].nSocialSecurityNumber >
                people[n+1].nSocialSecurityNumber)
            {
                // ...beide vertauschen...
                Person temp  = people[n+1];
                people[n+1] = people[n];
                people[n]   = temp;

                // ...und zhlen.
                nSwaps++;
            }
        }
    }
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Platz fr ein paar Namen reservieren
    Person people[128];

    // den Benutzer zur Eingabe auffordern
    cout << "Name/Sozialversicherungsnummer lesen\n";
    int nCount = getPeople(people, 128);

    // die Liste sortieren
    sortPeople(people, nCount);

    // jetzt die Ergebnisse anzeigen
    cout << "\nHier die Liste, sortiert nach "
         << "Sozialversicherungsnummer" << endl;
    displayPeople(people, nCount);

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
