//
//  NamedStudent - dieses Programm demonstriert die Verwendung
//               eines Konstruktors mit Argumenten
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;

class Student
{
  protected:
    char*  pszName;
    int    nID;

  public:
    Student(const char* pszNewName, int nNewID)
    {
        cout << "Konstruktion " << pszNewName << endl;
        int nLength = strlen(pszNewName) + 1;
        pszName = new char[nLength];
        strcpy(pszName, pszNewName);
        nID = nNewID;
    }
   ~Student()
    {
        cout << "Zerstren " << pszName << endl;
        delete[] pszName;
        pszName = nullptr;
    }

    // getName() - ermittelt den Namen des Studenten
    const char* getName()
    {
        return pszName;
    }

    // getID() - ermittelt die ID des Studenten
    int getID()
    {
        return nID;
    }
};

Student* fn()
{
    // einen Studenten erstellen und initialisieren
    cout << "Konstruktion eines lokalen Studenten in fn()" <<endl;
    Student student("Stephen Davis", 1234);

    // den Namen des Studenten anzeigen
    cout << "Der Name des Studenten ist "
         << student.getName() << endl;

    // jetzt einen Studenten auf dem Stapel reservieren
    cout << "Einen Studenten vom Stapel reservieren" << endl;
    Student *pS = new Student("Kinsey Davis", 5678);

    // den Namen dieses Studenten anzeigen
    cout << "Der Name des zweiten Studenten lautet "
         << pS->getName() << endl;

    cout << "Zurck von fn()" << endl;
    return pS;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // die Funktion aufrufen, die Student-Objekte erzeugt
    cout << "Auruf von fn()" << endl;
    Student* pS = fn();
    cout << "Zurck in main()" << endl;

    // das von fn() zurckgegebene Objekt lschen
    delete pS;
    pS = nullptr;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
