//
//  OverloadedStudent - dieses Programm berldt den Student-
//                 Konstruktor mit 3 verschiedenen Optionen,
//                 die sich anhand der Anzahl ihrer Argumente unterscheiden
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;

class Student
{
  protected:
    char*  pszName;
    int    nID;
    double dGrade;         // GPA des Studenten
    int    nSemesterHours;


  public:
    Student(const char* pszNewName, int nNewID,
            double dXferGrade, int nXferHours)
    {
        cout << "Konstruktion " << pszNewName
              << " als Gaststudent." << endl;
        int nLength = strlen(pszNewName) + 1;
        pszName = new char[nLength];
        strcpy(pszName, pszNewName);
        nID = nNewID;
        dGrade = dXferGrade;
        nSemesterHours = nXferHours;
    }
    Student(const char* pszNewName, int nNewID)
    {
        cout << "Konstruktion " << pszNewName
             << " als neuer Student." << endl;
        int nLength = strlen(pszNewName) + 1;
        pszName = new char[nLength];
        strcpy(pszName, pszNewName);
        nID = nNewID;
        dGrade = 0.0;
        nSemesterHours = 0;
    }
    Student()
    {
        pszName = nullptr;
        nID = 0;
        dGrade = 0.0;
        nSemesterHours = 0;
    }
   ~Student()
    {
        cout << "Destructing " << pszName << endl;
        delete[] pszName;
        pszName = nullptr;
    }

    // Zugriffsfunktionen
    const char* getName()
    {
        return pszName;
    }
    int getID()
    {
        return nID;
    }
    double getGrade()
    {
        return dGrade;
    }
    int getHours()
    {
        return nSemesterHours;
    }

    // addGrade - dem GPA eine Note hinzufgen und Stunden ermitteln
    double addGrade(double dNewGrade, int nHours)
    {
        double dWtdHrs = dGrade * nSemesterHours;
        dWtdHrs += dNewGrade * nHours;
        nSemesterHours += nHours;
        dGrade = dWtdHrs / nSemesterHours;
        return dGrade;
    }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    // einen Studenten erzeugen und initialisieren
    Student student("Stephen Davis", 1234);

    // jetzt einen Gaststudenten mit Anfangsnote erzeugen
    Student xfer("Kinsey Davis", 5678, 3.5, 12);

    // beiden Studenten in der aktuellen Klasse ein B geben
    student.addGrade(3.0, 3);
    xfer.addGrade(3.0, 3);

    // Name und Noten des Studenten anzeigen
    cout << "Student "
         << student.getName()
         << " hat die Note "
         << student.getGrade()
         << endl;

    cout << "Student "
         << xfer.getName()
         << " hat die Note "
         << xfer.getGrade()
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
