//
//  PassByReference - demonstriert die bergabe von Argumenten an eine
//                    Funktion als Wert und als Referenz.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// fn(int, int) - demonstriert eine weitere Funktion, die zwei
//                Argumente entgegennimmt und ihren Wert ndert
void fn(int nArg1, int nArg2)
{
    // den Wert der Argumente ndern
    nArg1 = 10;
    nArg2 = 20;
}

// fn(int*, int*) - diese Funktion nimmt ihre Argumente
//                  als Referenz entgegen
void fn(int* pnArg1, int* pnArg2)
{
    // den Wert des Arguments ndern
    *pnArg1 = 10;
    *pnArg2 = 20;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // zwei Variablen initialisieren und ihre Werte anzeigen
    int nValue1 = 1;
    int nValue2 = 2;
    cout << "Der Wert von nArg1 ist " << nValue1 << endl;
    cout << "Der Wert von nArg2 ist " << nValue2 << endl;

    // jetzt versuchen, sie durch Aufruf einer Funktion zu ndern
    cout << "Calling fn(int, int)" << endl;
    fn(nValue1, nValue2);
    cout << "Rckgabe von fn(int, int)" << endl;
    cout << "Der Wert von nArg1 ist " << nValue1 << endl;
    cout << "Der Wert von nArg2 ist " << nValue2 << endl;

    // erneut durch den Aufruf einer Funktion, die Adressen
    // als Argumente bernimmt
    cout << "Calling fn(int*, int*)" << endl;
    fn(&nValue1, &nValue2);
    cout << "Rckgabe von fn(int*, int*)" << endl;
    cout << "Der Wert von nArg1 ist " << nValue1 << endl;
    cout << "Der Wert von nArg2 ist " << nValue2 << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
