//
//  PassByReference2 - demonstriert die bergabe von Argumenten an eine
//                    Funktion als Wert und als Referenz unter Verwendung
//                    referentieller Typen
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// fn(int, int) - demonstriert eine Funktion, die zwei
//                Argumente bernimmt und ihren Wert ndert
void fn(int nArg1, int nArg2)
{
    // den Wert der Argumente ndern
    nArg1 = 10;
    nArg2 = 20;
}

// fn2(int&, int&) - diese Funktion verwendet den referentiellen
//                   Argumenttyp
void fn2(int& nArg1, int& nArg2)
{
    // den Wert der Argumente ndern
    nArg1 = 10;
    nArg2 = 20;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // zwei Variablen initialisieren und ihre Werte anzeigen
    int nValue1 = 1;
    int nValue2 = 2;
    cout << "Der Wert von nArg1 ist " << nValue1 << endl;
    cout << "Der Wert von nArg2 ist " << nValue2 << endl;

    // now try to modify them by calling a function
    cout << "Aufruf von fn(int, int)" << endl;
    fn(nValue1, nValue2);
    cout << "Rckgabe von fn(int, int)" << endl;
    cout << "Der Wert von nArg1 ist " << nValue1 << endl;
    cout << "Der Wert von nArg2 ist " << nValue2 << endl;

    // erneut probieren durch den Aufruf einer Funktion, die ihre
    // Argumente referentiell deklariert
    cout << "Aufruf von fn2(int&, int&)" << endl;
    fn2(nValue1, nValue2);
    cout << "Rckgabe von fn2(int, int)" << endl;
    cout << "Der Wert von nArg1 ist " << nValue1 << endl;
    cout << "Der Wert von nArg2 ist " << nValue2 << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
