//
//  ReadIntegers - dieses Programm liest ganze Zahlen aus der
//                 Eingabedatei MyFile.txt im aktuellen Verzeichnis.
//                 Die Funktion unsafeFn() berprft beim Lesen nicht
//                 auf Fehler, die Funktion safeFn() macht dies schon.
//
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <iostream>
using namespace std;

void unsafeFn()
{
    ifstream myFile("MyFile.txt");
    int nInputValue;

    for(int n = 1; n <= 10; n++)
    {
        // einen Wert lesen
        myFile >> nInputValue;

        // Wert erfolgreich gelesen - Ausgabe
        cout << n << " - " << nInputValue << endl;
    }
}

void safeFn()
{
    ifstream myFile("MyFile.txt");
    int nInputValue;

    for(int n = 1; n <= 10; n++)
    {
        // einen Wert lesen
        myFile >> nInputValue;

        // beim Lesefehler Schleife verlassen
        if (myFile.fail())
        {
            break;
        }

        // Wert erfolgreich gelesen - Ausgabe
        cout << n << " - " << nInputValue << endl;
    }
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // unsafeFn() oder safeFn() aufrufen
    unsafeFn();

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

