//
//  SimpleStudent - dieses Programm demonstriert, wie das Schlsselwort
//                  protected verwendet wird, um wichtige interne
//                  Elemente zu schtzen
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  protected:
    double dGrade;         // GPA des Studenten
    int    nSemesterHours;

  public:
    // init() - den Studenten mit einem korrekten Status initialisieren
    void init()
    {
        dGrade = 0.0;
        nSemesterHours = 0;
    }

    // getGrade() - die aktuelle NOte zurckgeben
    double getGrade()
    {
        return dGrade;
    }

    // getHours() - die Klassenstunden fr die Bewertung abrufen
    int getHours()
    {
        return nSemesterHours;
    }

    // addGrade - dem GPA eine Note hinzufgen und Stunden aufsummieren
    double addGrade(double dNewGrade, int nHours)
    {
        double dWtdHrs = dGrade * nSemesterHours;
        dWtdHrs += dNewGrade * nHours;
        nSemesterHours += nHours;
        dGrade = dWtdHrs / nSemesterHours;
        return dGrade;
    }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    // einen Studenten erstellen und initialisieren
    Student s;
    s.init();

    // die Noten fr drei Kurse hinzufgen
    s.addGrade(3.0, 3);  // ein B
    s.addGrade(4.0, 3);  // ein A
    s.addGrade(2.0, 3);  // ein C (Durchschnitt sollte B sein)

    // jetzt die Ergebnisse drucken
    cout << "Total # hours = " << s.getHours()
         << ", GPA = " << s.getGrade()
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
