// StringStream - demonstriert die Verwendung von String-Stream-
//                Klassen fr ein sicheres Parsing der Eingabe
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <string>
#include <cstring>
using namespace std;

struct Student
{
  protected:
    char szFirstName[256];
    char szLastName[256];
    int  nStudentID;

  public:
    Student(const char* pszFN, const char* pszLN,int nSID)
    {
        strncpy(szFirstName, pszFN, 256);
        strncpy(szLastName,  pszLN, 256);
        nStudentID = nSID;
    }

    // display - schreibt die Daten des Studenten in das
    //           bereitgestellte Array; die in nLength festgelegte
    //           Lnge des Arrays darf nicht berschritten werden
    void display(char* pszBuffer, int nLength)
    {
        ostringstream out;

        out << szFirstName << " " << szLastName
            << " [" << nStudentID << "]" << ends;
        string s = out.str();
        strncpy(pszBuffer, s.c_str(), nLength);
    }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    Student *pStudents[128];
    int nCount = 0;

    cout << "Eingabe Student <Nachname, Vorname ID>\n"
         << "(Leere Zeile beendet die Eingabe)" << endl;

    for(;;)
    {
        // eine weitere Zeile fr das Parsing abrufen
        char szLine[256];
        cin.getline(szLine, 256);

        // abbrechen bei leerer Zeile
        if (strlen(szLine) == 0)
        {
            break;
        }

        // dem gelesenen Array ein istrstream-Objekt zuordnen
        string s(szLine);
        istringstream input(s);

        // jetzt versuchen, den gelesenen Puffer zu parsen
        char szLastName[256];
        char szFirstName[256];
        int nSSID;

        // den Nachnamen bis zu einem Kommatrennzeichen lesen
        input.getline(szLastName, 256, ',');

        // Vornamen bis zu einem White Space lesen
        input >> szFirstName;

        // jetzt die Studenten-ID lesen
        input >> nSSID;

        // diese Zeile berspringen, wenn nichts funktioniert hat
        if (input.fail())
        {
            cerr << "Bad input: " << szLine << endl;
            continue;
        }

        // ein Student-Objekt mit den eingegebenen Daten erstellen
        // und im Pointer-Array speichern
        pStudents[nCount++] = new Student(szFirstName,
                                       szLastName, nSSID);
    }

    // Eingaben fr den Studenten anzeigen - Ausgabefunktion fr den
    // Studenten verwenden, um die Daten des Studenten zu formatieren
    for(int n = 0; n < nCount; n++)
    {
        char szBuffer[256];
        pStudents[n]->display(szBuffer, 256);
        cout << szBuffer << endl;
    }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
