//
//  StudentAssignment - dieses Programm demonstriert, wie ein
//                Zuweisungsoperator erzeugt wird, der dieselbe
//                tiefe Kopie wie der Copy-Konstruktor erzeugt
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;

class Student
{
  protected:
    char*  pszName;
    int    nID;

    void init(const char* pszNewName, int nNewID)
    {
        int nLength = strlen(pszNewName) + 1;
        pszName = new char[nLength];
        strcpy(pszName, pszNewName);
        nID = nNewID;
    }

    void destruct()
    {
        delete[] pszName;
        pszName = nullptr;
    }

  public:
    Student(const char* pszNewName, int nNewID)
    {
        cout << "Konstruktion " << pszNewName << endl;
        init(pszNewName, nNewID);
    }
    Student(Student& s)
    {
        cout<<"Konstruktion einer Kopie von "<< s.pszName << endl;
        init(s.pszName, s.nID);
    }

    virtual ~Student()
    {
        cout << "Zerstren " << pszName << endl;
        destruct();
    }

    // berladen des Zuweisungsoperators
    Student& operator=(const Student& source)
    {
        // nichts tun, wenn wir uns selbst zugeordnet sind
        if (this != &source)
        {
            cout << "Zuweisung " << source.pszName
                 << " to "       << pszName << endl;

            // zuerst das vorhandene Objekt zerstren
            destruct();

            // jetzt das Quellobjekt zerstren
            init(source.pszName, source.nID);
        }

        return *this;
    }


    // Zugriffsfunktionen
    const char* getName()
    {
        return pszName;
    }
    int getID()
    {
        return nID;
    }
};

void someFn()
{
    Student s1("Adam Laskowski", 1234);
    Student s2("Vanessa Barbossa", 5678);

    s2 = s1;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    someFn();

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
