//
//  StudentConstructor - dieses Programm demonstriert die Verwendung
//               eines Standardkonstruktors fr die Initialisierung
//               von Objekten, wenn sie erstellt werden
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  protected:
    double dGrade;         // GPA des Studenten
    int    nSemesterHours;

  public:
    // Konstruktor - initialisiert den Studenten in einem
    // zulssigen Status
    Student()
    {
        cout << "Konstruktion eines Student-Objekts" << endl;
        dGrade = 0.0;
        nSemesterHours = 0;
    }

    // getGrade() - Rckgabe der aktuellen Note
    double getGrade()
    {
        return dGrade;
    }

    // getHours() - Klassenstunden fr Bewertung abrufen
    int getHours()
    {
        return nSemesterHours;
    }

    // addGrade - dem GPA eine Note hinzufgen und Stunden aufaddieren
    double addGrade(double dNewGrade, int nHours)
    {
        double dWtdHrs = dGrade * nSemesterHours;
        dWtdHrs += dNewGrade * nHours;
        nSemesterHours += nHours;
        dGrade = dWtdHrs / nSemesterHours;
        return dGrade;
    }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    // einen Studenten erstellen und initialisieren
    cout << "Creating the Student s" << endl;
    Student s;

    // die Noten fr drei Klassen hinzufgen
    s.addGrade(3.0, 3);  // ein B
    s.addGrade(4.0, 3);  // ein A
    s.addGrade(2.0, 3);  // ein C (Durchschnitt sollte B sein)

    // jetzt die Ergebnisse ausgeben
    cout << "Gesamtzahl Stunden = " << s.getHours()
         << ", GPA = " << s.getGrade()
         << endl;

    // Array fr Studenten erzeugen
    cout << "Ein Array mit 5 Stundenten erzeugen" << endl;
    Student sArray[5];

    // jetzt auf dem Stapel reservieren
    cout << "Einen Studenten auf dem Stapel reservieren" << endl;
    Student *pS = new Student;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
